<template>
  <v-container fluid>
    <v-card
      class="mx-auto"
      :loading="!foundArchiveData"
    >
      <template v-if="foundArchiveData">
        <v-card-title class="mb-3">
          {{ foundArchiveData.title }}
        </v-card-title>

        <v-card-subtitle>{{ foundArchiveData.note }} </v-card-subtitle>

        <v-card-text>
          <div class="text-subtitle-1">
            <p class="mr-5">
              <small>Tags:</small>
            </p>
            <v-chip
              v-for="(currTag, tagKey) in foundArchiveData.tags"
              :key="tagKey"
              class="mr-1"
              small
            >
              {{ currTag.name }}
            </v-chip>
          </div>
        </v-card-text>

        <v-card-text>
          <div class="text-subtitle-1">
            <p class="mr-5">
              <small>Subjects:</small>
            </p>

            <v-chip
              v-for="(currSub, subKey) in foundArchiveData.subjects"
              :key="subKey"
              class="mr-1"
              small
            >
              {{ currSub.name }}
            </v-chip>
          </div>
        </v-card-text>

        <v-card-text>
          <div class="text-subtitle-1">
            <p class="mr-5">
              <small>Published Date:</small>
            </p>

            {{ foundArchiveData.published_date | $humanDate }}
          </div>
        </v-card-text>

        <v-divider />

        <v-card-actions class="pa-3 d-flex justify-end">
          <v-btn
            color="primary"
            @click="handleClickDownloadFile"
          >
            Download
          </v-btn>
        </v-card-actions>
      </template>
    </v-card>
  </v-container>
</template>

<script>
// eslint-disable-next-line no-unused-vars
import { mapActions, mapGetters, mapState, mapMutations } from 'vuex'

export default {
  name: 'StudentArchiveDetails',

  data () {
    return {
      selection: 1
    }
  },

  computed: {
    ...mapState('archives', {
      foundArchiveData: 'foundData'
    })
  },

  async created () {
    await this.bootstrap()
    console.log(this.foundArchiveData)
  },

  methods: {
    ...mapActions('archives', {
      findArchive: 'find'
    }),

    handleClickDownloadFile () {
      const uri = this.$toCDN(this.foundArchiveData.path)

      this.$download(uri)
    },

    async bootstrap () {
      try {
        await this.findArchive(this.$route.params.id)
      } catch (error) {
        console.log(error)
      }
    }
  }
}
</script>
